<?php

namespace Teknisa\MAN\Services;


use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services\NovoCodigo;
use \Setforms2\Shared\ORM\DateTime;

class Consumidor {
	
	protected $entityManager;
	protected $entityMetaDataConfig;

	public function __construct($entityManager, $entityMetaDataConfig)  {
		$this->entityManager = $entityManager;
		$this->entityMetaDataConfig = $entityMetaDataConfig;
	}

	public function buscaConsumidores($CDCLIENTE, $NRORG){
		$params = array(
			':CDCLIENTE' => $CDCLIENTE,
			':NRORG' => $NRORG
		);	
		
		$row = $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_CONSUMIDOR, $params);
		$rowclient = $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_CLIENTE_GERAL, $params);
		
		for ($i=0; count($row) > $i; $i++ ) {
			
			$row[$i]["NRINSJURCLIE"] = $rowclient[0]["NRINSJURCLIE"];
			$row[$i]["NMRAZSOCCLIE"] = $rowclient[0]["NMRAZSOCCLIE"];
			
		}
		return $row;
	
	}
	
	public function buscaVendasPorConsumidor($params){
		$dados = $this->entityManager->getConnection()->fetchAll(self::BUSCA_VENDAS_CONSUMIDOR, $params);
		return $dados;
	}
	
	
	
	
	public function getConsumidorAnon($query,$params){
		$result = $this->entityManager->getConnection()->fetchAll($query, $params);
		return $result;
	}
	
	
	
public function insertConsumidorAnon($params){

	
		$statement = $this->entityManager->getConnection()->prepare(self::INSERT_ANONIMIZACONS);
        
        $statement->bindParam(':CDCLIENTE',     	$params['CDCLIENTE'],         \PDO::PARAM_STR);
        $statement->bindParam(':CDCONSUMIDOR',      $params['CDCONSUMIDOR'],      \PDO::PARAM_STR);
        $statement->bindParam(':CDOPERADOR',		$params['CDOPERADOR'],        \PDO::PARAM_STR);
        $statement->bindParam(':NMOPERADOR',		$params['NMOPERADOR'],        \PDO::PARAM_STR);
        $statement->bindParam(':NMARQANONIMIZA',    $params['NMARQANONIMIZA'],    \PDO::PARAM_STR);
        $statement->bindParam(':DSARQANONIMIZA',    $params['DSARQANONIMIZA'],    \PDO::PARAM_LOB);

         $statement->execute();
        
        
		
	}

public function updateConsumidorAnon($params){
	
		
		$statement = $this->entityManager->getConnection()->prepare(self::UPDATE_ANONIMIZACONS);
        
        
	    $statement->bindParam(':NRCPFRESPCON',	  $params['NRCPFRESPCON'],  \PDO::PARAM_STR);
        $statement->bindParam(':NRRGCONSUMID',	  $params['NRRGCONSUMID'],	\PDO::PARAM_STR);
        $statement->bindParam(':NMCONSUMIDOR',	  $params['NMCONSUMIDOR'],	\PDO::PARAM_STR);
        $statement->bindParam(':NMRESPCONS',	  $params['NMRESPCONS'],	\PDO::PARAM_STR);
        $statement->bindParam(':DSEMAILCONS', 	  $params['DSEMAILCONS'],	\PDO::PARAM_STR);
        $statement->bindParam(':NRTELECONS',	  $params['NRTELECONS'],	\PDO::PARAM_STR);
        $statement->bindParam(':NRCELULARCONS',	  $params['NRCELULARCONS'],	\PDO::PARAM_STR);
        $statement->bindParam(':NRTELE2CONS', 	  $params['NRTELE2CONS'],	\PDO::PARAM_STR);
        $statement->bindParam(':CDIDCONSUMID',	  $params['CDIDCONSUMID'],	\PDO::PARAM_STR);
        $statement->bindParam(':CDCLIENTE',		  $params['CDCLIENTE'],		\PDO::PARAM_STR);
        $statement->bindParam(':CDCONSUMIDOR',	  $params['CDCONSUMIDOR'],	\PDO::PARAM_STR);
        
       $statement->execute();
 
       
	}


	public function buscaConsClienteBeneficio($CDCLIENTE, $CDCAMPANHA, $NRORG){
		$params = array(
			':CDCLIENTE' 	=> $CDCLIENTE,
			':CDCAMPANHA'   => $CDCAMPANHA,
			':NRORG' => $NRORG
			
		);
		
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_CONS_CLIBENEFICIO, $params);
	}

	public function buscaConsumidor($CDIDCONSUMID, $NRORG){
		$params = array(
			':CDIDCONSUMID' => $CDIDCONSUMID,
			':NRORG' => $NRORG							
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_CONSUMIDOR_ESPECIFICO, $params);
	}

	public function buscaConsumidorCompleto($CDCLIENTE, $CDCONSUMIDOR, $NRORG){
		$params = array(
			':CDCLIENTE' => $CDCLIENTE,
			':CDCONSUMIDOR' => $CDCONSUMIDOR,
			':NRORG' => $NRORG							
		);
		
		$result = $this->entityManager->getConnection()->fetchAll(Utilities\Query::DADOS_CONSUMIDOR, $params);
		$rowclient = $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_CLIENTE_GERAL, $params);
		for ($i=0; count($result) > $i; $i++ ) {
			
			
			$result[$i]["NRINSJURCLIE"] = $rowclient[0]["NRINSJURCLIE"];
			$result[$i]["NMRAZSOCCLIE"] = $rowclient[0]["NMRAZSOCCLIE"];
			
		}
		
		return $result;
	}

	public function buscaTipoConsumidor(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_TIPO_CONSUMIDOR);
	}
	
	public function buscaTipoConsumidorPorCliente($NRORG, $CDCLIENTE){
		$params = array(
			':CDCLIENTE' 	=> $CDCLIENTE,
			':NRORG' => $NRORG								
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_TIPO_CONSUMIDOR_POR_CLIENTE, $params);
	}

	public function buscaConsumidorEspecifico($CDCLIENTE, $CDCONSUMIDOR, $NRORG){
		$params = array(
			':CDCLIENTE' 	=> $CDCLIENTE,
			':CDCONSUMIDOR'   => $CDCONSUMIDOR,
			':NRORG' => $NRORG								
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_CONS_ESPECIFICO, $params);
	}

	public function alteraConsumidor($CDCLIENTE, $CDCONSUMIDOR, $NMCONSUMIDOR, $IDSITCONSUMI, $CDPAIS, $SGESTADO, $CDMUNICIPIO, $CDTIPOCONS, $CDCCUSCLIE, $CDIDCONSUMID,
							   $DSENDECONS, $NMBAIRCONS, $NRCEPCONS, $NRTELECONS, $NRRAMAL1CONS, $DSEMAILCONS, $IDVERSALDCON, $NRRGCONSUMID, $CDSENHACONS, $NRCPFRESPCON,
							   $NMRESPCONS, $NMLOGINCONS, $IDSEXOCONS, $DTNASCCONS, $CDSENHASITE, $IDTPVENDACONS, $NRCELULARCONS, $CDBAIRRO, $IDIMPCPFCUPOM,
							   $IDCADCONFLIBCON, $IDPERCONSPRODEX, $IDTPSELMANHA, $IDTPSEALMOCO, $IDTPSELTARDE, $CDSENHACONSUMIDORWEB, $DTVALIDADECONSUMIDOR,
							   $VRLIMDEBCONS,$VRMAXDEBCONS,$VRAVIDEBCONS, $IDATIVO, $NRORG){
					$params = array(
						':CDCLIENTE' => $CDCLIENTE,
						':CDCONSUMIDOR' => $CDCONSUMIDOR,
						':NMCONSUMIDOR' => $NMCONSUMIDOR, 
						':IDSITCONSUMI' => $IDSITCONSUMI, 
						':CDPAIS' => $CDPAIS, 
						':SGESTADO' => $SGESTADO, 
						':CDMUNICIPIO' => $CDMUNICIPIO, 
						':CDTIPOCONS' => $CDTIPOCONS, 
						':CDCCUSCLIE' => $CDCCUSCLIE, 
						':CDIDCONSUMID' => $CDIDCONSUMID, 
						':DSENDECONS' => $DSENDECONS, 
						':NMBAIRCONS' => $NMBAIRCONS, 
						':NRCEPCONS' => $NRCEPCONS, 
						':NRTELECONS' => $NRTELECONS,
						':NRRAMAL1CONS' => $NRRAMAL1CONS, 
						':DSEMAILCONS' => $DSEMAILCONS, 
						':IDVERSALDCON' => $IDVERSALDCON, 
						':NRRGCONSUMID' => $NRRGCONSUMID,
						':CDSENHACONS' => $CDSENHACONS, 
						':NRCPFRESPCON' => $NRCPFRESPCON, 
						':NMRESPCONS' => $NMRESPCONS, 
						':NMLOGINCONS' => $NMLOGINCONS,
						':IDSEXOCONS' => $IDSEXOCONS, 
						':DTNASCCONS' => $DTNASCCONS, 
						':CDSENHASITE' => $CDSENHASITE, 
						':IDTPVENDACONS' => $IDTPVENDACONS,
						':NRCELULARCONS' => $NRCELULARCONS,
						':CDBAIRRO' => $CDBAIRRO, 
						':IDIMPCPFCUPOM' => $IDIMPCPFCUPOM,
						':IDCADCONFLIBCON' => $IDCADCONFLIBCON, 
						':IDPERCONSPRODEX' => $IDPERCONSPRODEX,
						':IDTPSELMANHA' => $IDTPSELMANHA,
						':IDTPSEALMOCO' => $IDTPSEALMOCO,
						':IDTPSELTARDE' => $IDTPSELTARDE,
						':CDSENHACONSUMIDORWEB' => $CDSENHACONSUMIDORWEB,	
						':DTVALIDADECONSUMIDOR' => $DTVALIDADECONSUMIDOR,
						':VRLIMDEBCONS' => $VRLIMDEBCONS,
						':VRMAXDEBCONS' => $VRMAXDEBCONS,
						':VRAVIDEBCONS' => $VRAVIDEBCONS,
					    ':IDATIVO' => $IDATIVO,
						':NRORG' => $NRORG
						);
						 	 
						
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ATUALIZA_CONSUMIDOR, $params);
	}

	public function novoConsumidor($CDCLIENTE, $CDCONSUMIDOR, $NMCONSUMIDOR, $IDSITCONSUMI, $CDPAIS, $SGESTADO, $CDMUNICIPIO, $CDTIPOCONS, $CDCCUSCLIE, $CDIDCONSUMID,
							   $DSENDECONS, $NMBAIRCONS, $NRCEPCONS, $NRTELECONS, $NRRAMAL1CONS, $DSEMAILCONS, $IDVERSALDCON, $NRRGCONSUMID, $CDSENHACONS, $NRCPFRESPCON,
							   $NMRESPCONS, $NMLOGINCONS, $IDSEXOCONS, $DTNASCCONS, $CDSENHASITE, $IDTPVENDACONS, $NRCELULARCONS, $CDBAIRRO, $IDIMPCPFCUPOM,
							   $IDCADCONFLIBCON, $IDPERCONSPRODEX, $IDTPSELMANHA, $IDTPSEALMOCO, $IDTPSELTARDE, $CDSENHACONSUMIDORWEB, $DTVALIDADECONSUMIDOR,
							   $VRLIMDEBCONS,$VRMAXDEBCONS,$VRAVIDEBCONS, $NRORG){
					$params = array(
						':CDCLIENTE' => $CDCLIENTE,
						':CDCONSUMIDOR' => $CDCONSUMIDOR,
						':NMCONSUMIDOR' => $NMCONSUMIDOR, 
						':IDSITCONSUMI' => $IDSITCONSUMI, 
						':CDPAIS' => $CDPAIS, 
						':SGESTADO' => $SGESTADO, 
						':CDMUNICIPIO' => $CDMUNICIPIO, 
						':CDTIPOCONS' => $CDTIPOCONS, 
						':CDCCUSCLIE' => $CDCCUSCLIE, 
						':CDIDCONSUMID' => $CDIDCONSUMID, 
						':DSENDECONS' => $DSENDECONS, 
						':NMBAIRCONS' => $NMBAIRCONS, 
						':NRCEPCONS' => $NRCEPCONS, 
						':NRTELECONS' => $NRTELECONS,
						':NRRAMAL1CONS' => $NRRAMAL1CONS, 
						':DSEMAILCONS' => $DSEMAILCONS, 
						':IDVERSALDCON' => $IDVERSALDCON, 
						':NRRGCONSUMID' => $NRRGCONSUMID,
						':CDSENHACONS' => $CDSENHACONS, 
						':NRCPFRESPCON' => $NRCPFRESPCON, 
						':NMRESPCONS' => $NMRESPCONS, 
						':NMLOGINCONS' => $NMLOGINCONS,
						':IDSEXOCONS' => $IDSEXOCONS, 
						':DTNASCCONS' => $DTNASCCONS, 
						':CDSENHASITE' => $CDSENHASITE, 
						':IDTPVENDACONS' => $IDTPVENDACONS,
						':NRCELULARCONS' => $NRCELULARCONS,
						':CDBAIRRO' => $CDBAIRRO, 
						':IDIMPCPFCUPOM' => $IDIMPCPFCUPOM,
						':IDCADCONFLIBCON' => $IDCADCONFLIBCON, 
						':IDPERCONSPRODEX' => $IDPERCONSPRODEX,
						':IDTPSELMANHA' => $IDTPSELMANHA,
						':IDTPSEALMOCO' => $IDTPSEALMOCO,
						':IDTPSELTARDE' => $IDTPSELTARDE,
						':CDSENHACONSUMIDORWEB' => $CDSENHACONSUMIDORWEB,	
						':DTVALIDADECONSUMIDOR' => $DTVALIDADECONSUMIDOR,
						':VRLIMDEBCONS' => $VRLIMDEBCONS,
						':VRMAXDEBCONS' => $VRMAXDEBCONS,
						':VRAVIDEBCONS' => $VRAVIDEBCONS,
						':NRORG' => $NRORG
						);
						
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERE_CONSUMIDOR, $params);
	}
	
	public function resetSenha ($CDCLIENTE, $CDCONSUMIDOR){
		$params = array(
			':CDCLIENTE' 		=> $CDCLIENTE,
			':CDCONSUMIDOR' 	=> $CDCONSUMIDOR
			);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETA_SENHAMD5, $params);	
	}

	public function getConsumerByLogin($NMLOGINCONS){
		$params = array(
			':NMLOGINCONS' => $NMLOGINCONS
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_CONSUMER_DETAILS, $params); 
	}


	public function checkActivateCardByNMLOGINCONS($NMLOGINCONS){
		$params = array(
			':NMLOGINCONS' => $NMLOGINCONS			
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_CDIDCONSUMID_BY_NMLOGINCONS, $params);
	}

	public function updateHashAlteraSenhaConsu ($CDCONSUMIDOR, $CDCLIENTE, $DSHASHALTERASENHA) {
		$params = array(
			':CDCONSUMIDOR'      => $CDCONSUMIDOR,
			':CDCLIENTE'         => $CDCLIENTE,
			':DSHASHALTERASENHA' => $DSHASHALTERASENHA
		);
		$this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_HASH_ALTERASENHA_CONSUMIDOR, $params);
	}

	public function setInstitutionConnection ($connectionParams) {
		//For stablishing a connection with the right user given his NRORG
    	$this->entityManager = $this->entityManager->create($connectionParams, $this->entityMetaDataConfig);
	}
	
	public function checkConsumidores($CDCONSUMIDOR, $NRORG, $CDCLIENTE){
		$params = array(
			':CDCONSUMIDOR' => $CDCONSUMIDOR,
			':NRORG' => $NRORG,
			':CDCLIENTE' => $CDCLIENTE
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::CHECK_CODIGO_CONSUMIDOR, $params);	
	}
	
	public function findConsumidorAltAutomatica($CDCLIENTE, $CDCLIENTECUSCLIE, $CDTIPOCONSCLIE, $CDFILIAL, $NRORG){
		$params = array(
			':CDCLIENTECUSCLIE'  => $CDCLIENTECUSCLIE,
			':CDTIPOCONSCLIE'	 => $CDTIPOCONSCLIE,
			':CDCLIENTE'         => $CDCLIENTE,
			':CDFILIAL'			 => $CDFILIAL,
			":NRORG"			 => $NRORG
		);
		return $this->entityManager->getConnection()->fetchAll(self::GET_CONSUMIDOR_ALTERACAO_AUTOMATICA, $params);
	}
	public function findConsumidorRel($query,$params){
		
		return $this->entityManager->getConnection()->fetchAll($query, $params);
	}
	
	public function saveAltAutomaticaEveryone($rows){
		$retorno = [];
		$params = array(
			':CDCLIENTE' => implode("_",$rows['CDCLIENTE'])
        );
        if($rows['ENABLE_IDTPVENDACONS'] == 'S'){
        	$params_TPVENDA = $params;
        	$params_TPVENDA[':IDTPVENDACONS'] = $rows['IDTPVENDACONS'];
        	$this->entityManager->getConnection()->executeQuery(self::SAVE_ALTERACAO_AUTOMATICA_TPVENDA_EVERYONE, $params_TPVENDA);
        	array_push($retorno, 'IDTPVENDACONS');
        }
        
        if($rows['ENABLE_SALDO'] == 'S') {
        	$params_SALDO = $params;
	        $params_SALDO[':VRMESUBCONS'] =	$rows['VRMESUBCONS'];
	        $params_SALDO[':VRPESUBCONS'] = $rows['VRPESUBCONS'];
	        $this->entityManager->getConnection()->executeQuery(self::SAVE_ALTERACAO_AUTOMATICA_SALDO_EVERYONE, $params_SALDO);
	        array_push($retorno, 'SALDO');
        } 
        
        if(!empty($rows['IDVERSALDCON'])){
        	$params_SALDO_VND = $params;
            $params_SALDO_VND['IDVERSALDCON']	= $rows['IDVERSALDCON'];
	        if($rows['IDVERSALDCON'] == 'S') {
	            $params_SALDO_VND[':VRAVIDEBCONS'] 	= ($rows['VRAVIDEBCONS']  == (null || '')) ? 0 : $rows['VRAVIDEBCONS'];
	            $params_SALDO_VND[':VRMAXDEBCONS'] 	= ($rows['VRMAXDEBCONS']  == (null || '')) ? 0 : $rows['VRMAXDEBCONS'];
	            $params_SALDO_VND[':VRLIMDEBCONS'] 	= ($rows['VRLIMDEBCONS']  == (null || '')) ? 0 : $rows['VRLIMDEBCONS'];
	            $params_SALDO_VND[':VRAVICREDCONS']	= ($rows['VRAVICREDCONS'] == (null || '')) ? 0 : $rows['VRAVICREDCONS'];
	            $params_SALDO_VND[':VRLIMCREDCONS']	= ($rows['VRLIMCREDCONS'] == (null || '')) ? 0 : $rows['VRLIMCREDCONS'];
	            $params_SALDO_VND[':VRMAXCREDCONS']	= ($rows['VRMAXCREDCONS'] == (null || '')) ? 0 : $rows['VRMAXCREDCONS'];
	            $this->entityManager->getConnection()->executeQuery(self::SAVE_ALTERACAO_AUTOMATICA_SALDO_VND_EVERYONE, $params_SALDO_VND);
	        }
	        	$this->entityManager->getConnection()->executeQuery(self::SAVE_ALTERACAO_AUTOMATICA_SALDO_VND_ID_EVERYONE, $params_SALDO_VND);
	            array_push($retorno, 'IDVERSALDCON');
        }
        
        if($rows['ENABLE_CDCCUSCLIE'] == 'S'){
        	$params_CDCCUSCLIE = $params;
            $params_CDCCUSCLIE[':P_CDCCUSCLIE'] = $rows['P_CDCCUSCLIE'];
			$this->entityManager->getConnection()->executeQuery(self::SAVE_ALTERACAO_AUTOMATICA_CDCCUSCLIE_EVERYONE, $params_CDCCUSCLIE);
			array_push($retorno, 'CDCCUSCLIE');
        }
        
        if($rows['ENABLE_CDTIPOCONS'] == 'S'){
        	$params_CDTIPOCONS = $params;
            $params_CDTIPOCONS[':P_CDTIPOCONS'] = $rows['P_CDTIPOCONS'];
            $this->entityManager->getConnection()->executeQuery(self::SAVE_ALTERACAO_AUTOMATICA_CDTIPOCONS_EVERYONE, $params_CDTIPOCONS);
            array_push($retorno, 'CDTIPOCONS');
        }
		    
	}
	
	public function saveAltAutomatica($rows){
		$retorno = [];
		$params = array(
			':CDCLIENTE' 		 => implode("_",$rows['CDCLIENTE']),
            ':CDCLIENTIPOCONS'   => implode("_",$rows['CODIGO']),
            ':CDCLIENTECUSCLIE'  => implode("_",$rows['CDCLIENTECUSCLIE']),
            ':CDCLIENCONSUMIDOR' => is_array($rows['CDCLIENCONSUMIDOR']) ? implode("_",$rows['CDCLIENCONSUMIDOR']) : "" 
        );
        if($rows['ENABLE_IDTPVENDACONS'] == 'S'){
        	$params_TPVENDA = $params;
        	$params_TPVENDA[':IDTPVENDACONS'] = $rows['IDTPVENDACONS'];
        	$this->entityManager->getConnection()->executeQuery(self::SAVE_ALTERACAO_AUTOMATICA_TPVENDA, $params_TPVENDA);
        	array_push($retorno, 'IDTPVENDACONS');
        }
        
        if($rows['ENABLE_SALDO'] == 'S') {
        	$params_SALDO = $params;
	        $params_SALDO[':VRMESUBCONS'] = $rows['VRMESUBCONS'];
	        $params_SALDO[':VRPESUBCONS'] =	$rows['VRPESUBCONS'];
	        $this->entityManager->getConnection()->executeQuery(self::SAVE_ALTERACAO_AUTOMATICA_SALDO, $params_SALDO);
	        array_push($retorno, 'SALDO');
        } 
        
        if(!empty($rows['IDVERSALDCON'])){
        	$params_SALDO_VND = $params;
            $params_SALDO_VND['IDVERSALDCON']	= $rows['IDVERSALDCON'];
	        if($rows['IDVERSALDCON'] == 'S') {
	            $params_SALDO_VND[':VRAVIDEBCONS'] 	= ($rows['VRAVIDEBCONS']  == (null || '')) ? 0 : $rows['VRAVIDEBCONS'];
	            $params_SALDO_VND[':VRMAXDEBCONS'] 	= ($rows['VRMAXDEBCONS']  == (null || '')) ? 0 : $rows['VRMAXDEBCONS'];
	            $params_SALDO_VND[':VRLIMDEBCONS'] 	= ($rows['VRLIMDEBCONS']  == (null || '')) ? 0 : $rows['VRLIMDEBCONS'];
	            $params_SALDO_VND[':VRAVICREDCONS']	= ($rows['VRAVICREDCONS'] == (null || '')) ? 0 : $rows['VRAVICREDCONS'];
	            $params_SALDO_VND[':VRLIMCREDCONS']	= ($rows['VRLIMCREDCONS'] == (null || '')) ? 0 : $rows['VRLIMCREDCONS'];
	            $params_SALDO_VND[':VRMAXCREDCONS']	= ($rows['VRMAXCREDCONS'] == (null || '')) ? 0 : $rows['VRMAXCREDCONS'];
	            $this->entityManager->getConnection()->executeQuery(self::SAVE_ALTERACAO_AUTOMATICA_SALDO_VND, $params_SALDO_VND);
	        }
	        	$this->entityManager->getConnection()->executeQuery(self::SAVE_ALTERACAO_AUTOMATICA_SALDO_VND_ID, $params_SALDO_VND);
	            array_push($retorno, 'IDVERSALDCON');
        }
        
        if($rows['ENABLE_CDCCUSCLIE'] == 'S'){
        	$params_CDCCUSCLIE = $params;
            $params_CDCCUSCLIE[':P_CDCCUSCLIE'] = $rows['P_CDCCUSCLIE'];
			$this->entityManager->getConnection()->executeQuery(self::SAVE_ALTERACAO_AUTOMATICA_CDCCUSCLIE, $params_CDCCUSCLIE);
			array_push($retorno, 'CDCCUSCLIE');
        }
        
        if($rows['ENABLE_CDTIPOCONS'] == 'S'){
        	$params_CDTIPOCONS = $params;
            $params_CDTIPOCONS[':P_CDTIPOCONS'] = $rows['P_CDTIPOCONS'];
            $this->entityManager->getConnection()->executeQuery(self::SAVE_ALTERACAO_AUTOMATICA_CDTIPOCONS, $params_CDTIPOCONS);
            array_push($retorno, 'CDTIPOCONS');
        }
		    
	}
	
	
	public function saveConsumidor($dados, $client, $startRow, $maxRow){
		//tratar valores
		$retorno = array(
			'status'        => true,
			'rowsSucess'    => 0,
			'rowsError'     => 0,
			'logRowsError'  => '',
			'logRowsSucess' => '',
			'logs'          => ''
		);
		
		$array = $this->tratarDados($dados);
		
		if(!empty($array)){
			foreach($array as $key => $value){
				if($key >= $startRow && $key <= $maxRow) {
					try {
						self::controlTransaction('begin');
						$ret = $this->saveInsertImportacao($value, $client);
						
						if(!empty($ret) and $ret['status']){
							$params = $ret['params'];
							$savePontos = $this->savePontos($params);
							
							//ira chamar funcao de inserir pontos
							if($savePontos['status']){
								$retorno['rowsSucess'] += 1;
								$retorno['logRowsSucess'] .= 'Consumidor '. $params[':CDCONSUMIDOR']. ' - '. $params[':NMCONSUMIDOR']. ' => INSERIDO COM SUCESSO!' . PHP_EOL;	
								
							}else{
								$retorno['rowsError'] += 1;
								$retorno['logRowsError'] .= 'Consumidor '. $params[':CDCONSUMIDOR']. ' - '. $params[':NMCONSUMIDOR']. ' => ERRO AO SALVAR PONTOS!' . PHP_EOL;	
								$retorno['logRowsError'] .= $savePontos['mensagem'];
							}
							$retorno['logs'] .= $ret['logs'];
						}else{
							$retorno['rowsError'] += 1;
							$retorno['logRowsError'] .= $ret['logRowsError'];
							$retorno['logRowsSucess'] .= $ret['logRowsSucess'];
							$retorno['logs'] .= $ret['logs'];
						}	
						self::controlTransaction('commit');
					} catch(\Exception $e){
						self::controlTransaction('rollback');
						throw $e;
					}
				}
			}
		}else{
			$retorno['status'] = false;
			$retorno['message'] = "Erro ao validar o cabeçalho do arquivo ou há linha(s) vazia(s) no arquivo";
		}
		
		return $retorno;
	}
	
	public function tratarDados($dados){
		$arrayRetorno = array();
		
		if(!empty($dados)){
			$arrayCabecalho = $dados[1];
			//retira o cabecalho
			
			if($this->validaCabecalho($arrayCabecalho)){
				unset($dados[1]);
				
				foreach($dados as $key => $value){
					if($this->verificaArrayVazio($value)){
						foreach($value as $k => $v){
							$arrayRetorno[$key][$arrayCabecalho[$k]] = $v;
						}
					}
				}
			}
		}
		
		return $arrayRetorno;
	}
	
	private function validaCabecalho($arrayCabecalho){
		
		$retorno = true;
		$fieldsCabecalho = array('CODCONS','CARTAO', 'NOME', 'CADASTRO', 'EMAIL','SEXO','ENDERECO', 'BAIRRO', 'CIDADE', 'UF', 'CEP', 'FONE1', 'FONE2', 'NASC', 'CPF', 'STATUS', 'SLDPONTOS', 'CENTRO DE CUSTO', 'TIPO DE CONSUMIDOR', 'CAMPANHA');
		
		foreach($fieldsCabecalho as $key => $value){
			if (!in_array($value, $arrayCabecalho)) {
				$retorno = false;
			}
		}
		
		return $retorno;
	}
	
	public function verificaArrayVazio($array){
		$retorno = false;
		foreach($array as $key => $value){
			if(!empty($value)){
				return true;
			}
		}
		return $retorno;
	}
	
	public function saveInsertImportacao($row, $client){
		
		$params = $this->returnParams($row, $client);
		
		$retorno = array(
			'status'        => true,
			'rowsSucess'    => 0,
			'rowsError'     => 0,
			'logRowsError'  => '',
			'logRowsSucess' => '',
			'logs'          => '',
			'params'        => $params
		);
		
		if($this->validaDados($params)){
			try{
				// verifica se ha cadastro do mesmo consumidor
				$count = $this->entityManager->getConnection()->fetchAll(self::GET_CONSUMIDOR_IMPORTADO, $params);
			
				if($count[0]['TOT'] == 0){
					// valida cpf e acrescenta senha
					// acrescenta 0 a esquerda para completar 
					if(!empty($NRCPFRESPCON)) {
						if(!$params[':NRCPFRESPCON']){
							$params[':NRCPFRESPCON'] = str_pad($params[':NRCPFRESPCON'], 11, "0", STR_PAD_LEFT);
						}
					}
					
					if($this->validateCPF($params[':NRCPFRESPCON'])){
						$params[':CDSENHACONSMD5'] = self::encrypt(substr($params[':NRCPFRESPCON'], 0, 3));
						
						$this->entityManager->getConnection()->executeQuery(self::INSERT_CONSUMIDOR_IMPORTADO,$params);
						
						$retorno['rowsSucess'] = 1;
						$retorno['logRowsSucess'] .= 'Consumidor '. $params[':CDCONSUMIDOR']. ' - '. $params[':NMCONSUMIDOR']. ' => INSERIDO COM SUCESSO!' . PHP_EOL;	
					}else{
						$retorno['logRowsError'] = 'Consumidor '. $params[':CDCONSUMIDOR']. ' - '. $params[':NMCONSUMIDOR']. ' => NÃO FOI INSERIDO, CPF INVÁLIDO!' . PHP_EOL;
						$retorno['rowsError'] = 1;
						$retorno['status'] = false;
					}
				}else{
					$retorno['logRowsError'] = 'Consumidor '. $params[':CDCONSUMIDOR']. ' - '. $params[':NMCONSUMIDOR']. ' => NÃO FOI INSERIDO, CODCONS ou CPF EXISTENTE!' . PHP_EOL;
					$retorno['rowsError'] = 1;
					$retorno['status'] = false;
				}
			}catch(\Exception $e){
				$retorno['logs'] = $e->getMessage() . PHP_EOL;
				$retorno['rowsError'] = 1;
				$retorno['status'] = false;
			}
		}else{
			$retorno['logRowsError'] = 'Consumidor '. $params[':CDCONSUMIDOR']. ' - '. $params[':NMCONSUMIDOR']. ' => ERRO AO VALIDAR PARÂMETROS! Verifique se todos os campos estão preenchidos de acordo com a manual e/ou se há Centro de Custo cadastrado para o cliente selecionado!' . PHP_EOL ;
			$retorno['rowsError'] = 1;
			$retorno['status'] = false;
			
		}
		
		return $retorno;
	}
	
   private function validanumber($params){
		if(!is_numeric($params)){
            return true;
		}else{ 
			return false;
		 }
   }
   
   private function validaData($data, $format = 'd/m/Y'){
		$d = DateTime::createFromFormat($format, $data);
		return $d && $d->format($format) == $data;
   }
	
	private function validaDados($params){
		$retorno = true;
		
		if(!empty($params)){
			if( empty($params[':CDIDCONSUMID']) || 
				empty($params[':NMCONSUMIDOR']) ||
				empty($params[':IDATIVO']) ||
				empty($params[':IDSITCONSUMI']) ||
				empty($params[':CDCLIENTE']) ||
				empty($params[':NRORG']) ||
				empty($params[':CDCCUSCLIE']) ||
				empty($params[':CDCONSUMIDOR']) ){
				$retorno = false;
			}
			
			if(empty($params[':SLDPONTOS']) && $params[':SLDPONTOS'] !== 0.0 ){
				$retorno = false;
			}
			
			if(!empty($params[':SLDPONTOS']) && $this->validanumber($params[':SLDPONTOS'])){
				$retorno = false;
			}
			if (!empty($params[':DTNASCCONS']) && !$this->validaData($params[':DTNASCCONS'])) {
                $retorno = false;
            }
           	if (!empty($params[':DTCRIACONS']) && !$this->validaData($params[':DTCRIACONS'])) {
                $retorno = false;
            }
            if (!empty($params[':DTINCLUSAO']) && !$this->validaData($params[':DTINCLUSAO'])) {
                $retorno = false;
            }
            if($params[':CDCCUSCLIE']=='ERROR'){
				$retorno = false;
			}
			if($params[':CDTIPOCONS']=='ERROR'){
				$retorno = false;
			}
			if($params[':IDSEXOCONS']=='F'|| $params[':IDSEXOCONS']=='M'){
			}else{
				$retorno = false;
			}
		}else{
			$retorno = false;
		}
		return $retorno;
	}
	
	private function savePontos($params){
		$par = $this->returnParamsPontos($params);
		$retorno = array('status' => true, 'mensagem' => "");
		
		try{
			
			if($par[':VRMOVPONTOCONS'] != '0.00' &&  $par[':VRMOVPONTOCONS'] != '0,00' && $par[':VRMOVPONTOCONS'] != '0'){
				$this->entityManager->getConnection()->executeQuery(self::INSERT_CONSUMIDOR_MOVPONTOCONS,$par);
			}
			$retorno['mensagem'] = "Salvo com sucesso.";
			$retorno['status'] = true;
		}catch(\Exception $e){
			$retorno['mensagem'] = "Erro: ".$e->getMessage();
			$retorno['status'] = false;
		}
		return $retorno;
	}
	
	private function returnParamsPontos($par){
		$params = array();
		
		foreach($par as $key => $value){
			
			if($key == ':CDIDCONSUMID'){
				$params[':CDIDCONSUMID'] = $value;
			}
			
			if($key == ':CDCLIENTE'){
				$params[':CDCLIENTE'] = $value;
			}
			
			if($key == ':NRORG'){
				$params[':NRORG'] = $value;
			}
			
			if($key == ':CDCONSUMIDOR'){
				$params[':CDCONSUMIDOR'] = $value;
			}
			
			if($key == ':SLDPONTOS'){
				$params[':VRMOVPONTOCONS'] = $value;
				$params[':VRSALDOCONS'] = $value;
			}
			
			if($key == ':CDCAMPANHA') {
				$params[':CDCAMPANHA'] = $value;
			}
		}
		
		$params[':NRSEQMOVCONS']    = $this->getNovoCodigoSeq('MOVPONTOCONS'.$params[':CDCAMPANHA'].$params[':CDCLIENTE'].$params[':CDCONSUMIDOR'],$params[':NRORG']);
		$params[':IDTPMOVCONS']     = 'C';
		$params[':DSOBSMOVPTOCONS'] = 'Pontuação de vendas';
		$params[':IDATIVO']         = 'S';
		$params[':DTINCLUSAO']      = date('d/m/Y');
		$params[':DTULTATU']        = date('d/m/Y');
		$params[':DTMOVPONTOCONS']  = date('d/m/Y');
		
		return $params;
	}
	
	private function getCampanha(){
		$campanha = $this->entityManager->getConnection()->fetchAll(self::GET_CAMAPANHA);
		if(!empty($campanha)){
			$cp = $campanha[0]['CDCAMPANHA'];
		}else{
			$cp = '';
		}
		return $cp;
	}
	
	private function returnParams($row,$client){
		$params = array();
		
		foreach($row as $key => $value){
			if($key == 'CENTRO DE CUSTO'){
				$params[':CDCCUSCLIE'] = trim($this->soNumero($value));
			}
			
			if($key == 'TIPO DE CONSUMIDOR'){
				$params[':CDTIPOCONS']= trim($this->soNumero($value));
			}
			
			if($key == 'CARTAO'){
				$params[':CDIDCONSUMID'] = $this->upperCase($value, true);
			}
			
			if($key == 'NOME'){ 
				$params[':NMCONSUMIDOR'] = trim($this->limitarString($this->upperCase($value), 49));
			}
			
			if($key == 'CADASTRO'){
				$params[':DTCRIACONS'] = \PHPExcel_Style_NumberFormat::toFormattedString($value, 'DD/MM/YYYY');
				$params[':DTINCLUSAO'] = \PHPExcel_Style_NumberFormat::toFormattedString($value, 'DD/MM/YYYY');
			}
			
			if($key == 'EMAIL'){
				$params[':DSEMAILCONS'] = trim($this->limitarString($value, 49));
			}
			
			if($key == 'ENDERECO'){
				$params[':DSENDECONS'] = trim($this->limitarString($this->upperCase($value), 50));
			}
			
			if($key == 'BAIRRO'){
				$params[':CDBAIRRO'] = $value;
			}
			
			if($key == 'CEP'){
				$params[':NRCEPCONS'] = trim($this->soNumero($value));
			}
			
			if($key == 'FONE1'){
				$params[':NRTELECONS'] = trim($this->soNumero($value));
			}
			
			if($key == 'FONE2'){
				$params[':NRCELULARCONS'] = trim($this->soNumero($value));
			}
			
			if($key == 'STATUS'){
				$params[':IDATIVO'] = ($value == 'Ativado') ? 'S' : 'N';
			}
			
			if($key == 'CIDADE'){
				$params[':CDMUNICIPIO'] = $value;
			}
			
			if($key == 'UF'){
				$params[':SGESTADO'] = $value;
			}
			
			if($key == 'CPF'){
				$params[':NRCPFRESPCON'] = $this->soNumero($value);
			}
			
			if($key == 'NASC'){
				$params[':DTNASCCONS'] = \PHPExcel_Style_NumberFormat::toFormattedString($value, 'DD/MM/YYYY');
			}
			
			if($key == 'PTACUM'){
				$params[':PTACUM'] = $value;
			}
			
			if($key == 'PTUSU'){
				$params[':PTUSU'] = $value;
			}
			
			if($key == 'SLDPONTOS'){
				$params[':SLDPONTOS'] = $value;
			}
			
			if($key == 'TOTCOMP'){
				$params[':TOTCOMP'] = $value;
			}
			
			if($key == 'QTDTRANS'){
				$params[':QTDTRANS'] = $value;
			}
			
			if($key == 'SEXO'){
				$params[':IDSEXOCONS'] = $value;
			}
			
			
			$params[':IDSITCONSUMI'] = '1';
			$params[':CDCLIENTE'] = $client;
			$params[':NRORG'] = '';
			$params[':DTULTATU'] = date('d/m/Y');
			
			if($key == 'CODCONS'){
				$params[':CDCONSUMIDOR'] = $this->upperCase($value, true);
			}
			
			$params[':CDPAIS'] = '';
			
			if($key == 'CAMPANHA'){
				$params[':CDCAMPANHA'] = $value;
			}
		}
		
		//busca informacoes cdccuscli e nrorg
		if($params[':CDCCUSCLIE'] == ''){
			$params = $this->buscaCustoCliente($params);
		}
		else{
			$params[':CDCCUSCLIE'] = str_pad($params[':CDCCUSCLIE'], 10 , '0' , STR_PAD_LEFT);
			$params = $this->buscaCustoClienteSelecionado($params);
		}	
		
		//busca informacoes tipo consumidor padrao DA PARAMGERAL
		if($params[':CDTIPOCONS'] == ''){
			$params = $this->buscaTipoConsumidorPadrao($params);
		}
		else{
			$params[':CDTIPOCONS'] = sprintf("%02d", $params[':CDTIPOCONS']);
			$params = $this->buscaTipoConsumidorSelecionado($params);
		}
		
		//busca informacoes estado e pais
		$params = $this->buscaEstado($params);
		
		//busca informacoes municipios
		$params = $this->buscaMunicipio($params);
		
		//busca informacoes bairro
		$params = $this->buscaBairro($params);
		
		if(!empty($params[':CDCONSUMIDOR'])){
			//gera cdconsumidor
			$params = $this->getNovoCodigo($params);
		}else{
			$params = $this->getNovoCodigo($params, ':CDIDCONSUMID');
		}
		
		return $params;
	}
	
	public static function encrypt($text, $salt = 'setforms') {
        return md5('odhen'.$text.'7833');
    }

    public static function decrypt($text, $salt = 'odhen'){
        return trim(
            mcrypt_decrypt(
                MCRYPT_RIJNDAEL_256,
                $salt,
                base64_decode($text),
                MCRYPT_MODE_ECB,
                mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND)
            )
        );
    }
	
	
	
	private function soNumero($str) {
	    return preg_replace("/[^0-9]/", "", $str);
	}
	
	private function upperCase($text, $noSpecials = false){
		return mb_strtoupper($this->noSpecials($text, $noSpecials), 'UTF-8');
	}
	
	private function limitarString($string, $limit){
		return substr($string, 0, $limit);
	}
	
	private function getNovoCodigoSeq ($CDCONTADOR, $NRORG) {
	    return NovoCodigo::geraCodigo($this->entityManager->getConnection(), $CDCONTADOR, $NRORG, 10);
	}
	
	private function noSpecials($texto, $noSpecials){
		/* função que gera uma texto limpo:
		- limpa acentos e transforma em letra normal
		- limpa cedilha e transforma em c normal, o mesmo com o ñ
		- transforma espaços em hifen (-)
		- tira caracteres invalidos
		by Micox - elmicox.blogspot.com - www.ievolutionweb.com
		*/
		//desconvertendo do padrão entitie (tipo á para á)
		$texto = trim(html_entity_decode($texto));
		
		if($noSpecials){
			//tirando os acentos
			$texto= preg_replace('![áàãâä]+!u','a',$texto);
			$texto= preg_replace('![éèêë]+!u','e',$texto);
			$texto= preg_replace('![íìîï]+!u','i',$texto);
			$texto= preg_replace('![óòõôö]+!u','o',$texto);
			$texto= preg_replace('![úùûü]+!u','u',$texto);
			//parte que tira o cedilha e o ñ
			$texto= preg_replace('![ç]+!u','c',$texto);
			$texto= preg_replace('![ñ]+!u','n',$texto);	
		}
		
		//tirando outros caracteres invalidos
		$texto= preg_replace('[^a-z0-9\-]','-',$texto);
		//tirando espaços
		//$texto = str_replace(' ','-',$texto);
		//trocando duplo espaço (hifen) por 1 hifen só
		$texto = str_replace('--','-',$texto);
	
		return strtolower($texto);
	}
	
	public function controlTransaction($type){
    // controla transação com banco    
        try {
            switch ($type) {
                case 'begin':
                // inicia transação sem auto-commit
                    $this->entityManager->getConnection()->beginTransaction();
                    break;
                case 'commit':
                // salva transação
                    $this->entityManager->getConnection()->commit();
                    break;
                case 'rollback':
                // descarta transação
                    $this->entityManager->getConnection()->rollBack();
                    break;
            }
        } catch (\Exception $e) {
            /*$this->escreverLog('Erro: '.$e->getMessage());
            $this->finalizaLog('Erro!', 'Erro');
            $email ? $this->smtp->sendEmailMessage("manage", $email, $this->emailOrig, $this->logConsolidation) : 0;
            throw $e;*/
        }
    }
    
    private function getNovoCodigo ($params, $campo = ':CDCONSUMIDOR') {
    	$params[':CDCONSUMIDOR'] = 	str_pad($params[$campo], 21, "0", STR_PAD_LEFT);
    	return $params;
	}
    
    public function buscaCustoCliente($params){
    	$params_CUSTOCLIENTE[':CDCLIENTE'] = $params[':CDCLIENTE'];
		$result = $this->entityManager->getConnection()->fetchAll(self::GET_CUSTOCLIENTE, $params_CUSTOCLIENTE);
		if(!empty($result)){
			$params[':CDCCUSCLIE'] = $result[0]['CDCCUSCLIE'];
			$params[':NRORG'] = $result[0]['NRORG'];
		}
		
		return $params;
    }
    public function buscaCustoClienteSelecionado($params){
    	$params_CUSTOCLIENTE[':CDCLIENTE'] = $params[':CDCLIENTE'];
		$result = $this->entityManager->getConnection()->fetchAll(self::GET_CUSTOCLIENTE_SELECIONADO, $params);
		if(!empty($result)){
			$params[':CDCCUSCLIE'] = $result[0]['CDCCUSCLIE'];
			$params[':NRORG'] = $result[0]['NRORG'];
		}
		else{
			$params[':CDCCUSCLIE'] = 'ERROR';
		}
		
		return $params;
    }
    
    
    public function buscaTipoConsumidorCliente($params){
    	$params_CUSTOCLIENTE[':CDCLIENTE'] = $params[':CDCLIENTE'];
    	var_dump($params_CUSTOCLIENTE);die;
		$result = $this->entityManager->getConnection()->fetchAll(self::GET_TIPOCONSCLIENTE, $params_CUSTOCLIENTE);
		if(!empty($result)){
			$params[':CDTIPOCONS'] = $result[0]['CDTIPOCONS'];
		}
		return $params;
    }
    
    public function buscaTipoConsumidorPadrao($params){
		$result = $this->entityManager->getConnection()->fetchAll(self::GET_TIPOCONSPADRAO);
		if(!empty($result)){
			$params[':CDTIPOCONS'] = $result[0]['CDTIPOCONS'];
		}
		return $params;
    }
    public function buscaTipoConsumidorSelecionado($params){
    	$params_CDTIPOCONS[':CDTIPOCONS'] = $params[':CDTIPOCONS'];
		$result = $this->entityManager->getConnection()->fetchAll(self::GET_TIPOCONSELECIONADO, $params_CDTIPOCONS);
		if(!empty($result)){
			$params[':CDTIPOCONS'] = $result[0]['CDTIPOCONS'];
		}
		else{
			$params[':CDTIPOCONS'] = 'ERROR';
		}
		return $params;
    }
    
    private function buscaEstado($params){
    	
    	$params_ESTADO[':SGESTADO'] = $this->upperCase($params[':SGESTADO']);
		$params_ESTADO[':NMESTADO'] = $this->upperCase($params[':SGESTADO']);
		
		$result = $this->entityManager->getConnection()->fetchAll(self::GET_ESTADO, $params_ESTADO);
		if(!empty($result)){
			$params[':SGESTADO'] = $result[0]['SGESTADO'];
			$params[':CDPAIS'] = $result[0]['CDPAIS'];
		}else{
			$params[':SGESTADO'] = '';
			$params[':CDPAIS'] = '';
		}
		return $params;
    }
    
    private function buscaMunicipio($params){
    	
		$params_MUNICIPIO[':NMMUNICIPIO'] = $this->upperCase($params[':CDMUNICIPIO']);
		$params_MUNICIPIO[':NMMUNICIPIO2'] = $this->upperCase($params[':CDMUNICIPIO'], true);
		
		$result = $this->entityManager->getConnection()->fetchAll(self::GET_MUNICIPIO, $params_MUNICIPIO);
		
		if(!empty($result)){
			$params[':CDMUNICIPIO'] = $result[0]['CDMUNICIPIO'];
			if(empty($params[':CDPAIS'])){
				$params[':CDPAIS'] = $result[0]['CDPAIS'];
			}
			if(empty($params[':SGESTADO'])){
				$params[':SGESTADO'] = $result[0]['SGESTADO'];
			}
		}else{
			
			//verifica se ha dados para inserir na table de municipio
			if(!empty($params[':CDPAIS']) && !empty($params[':SGESTADO']) && !empty($params_MUNICIPIO[':NMMUNICIPIO2']) && !empty($params[':NRORG'])){
				$params_insert_municipio = array();
				$params_insert_municipio[':CDPAIS'] = $params[':CDPAIS'];
				$params_insert_municipio[':SGESTADO'] = $params[':SGESTADO'];
				$params_insert_municipio[':CDMUNICIPIO'] = $this->lastMunicipio($params[':SGESTADO']);
				$params_insert_municipio[':NMMUNICIPIO'] = $params_MUNICIPIO[':NMMUNICIPIO2'];
				$params_insert_municipio[':IDMUNIUTCONVNFE'] = 'N';
				$params_insert_municipio[':NRORG'] = $params[':NRORG'];
				$params_insert_municipio[':DTINCLUSAO'] = date('d/m/Y');
				$params_insert_municipio[':IDATIVO'] = 'S';
				
				if($this->saveMunicipio($params_insert_municipio)){
					$params[':CDMUNICIPIO'] = $params_insert_municipio[':CDMUNICIPIO'];
				}else{
					$params[':CDMUNICIPIO'] = '';
				}
			}else{
				$params[':CDMUNICIPIO'] = '';
			}
		}
		return $params;
    }
    
    private function saveMunicipio($params){
		self::controlTransaction('begin');
		try{
			$this->entityManager->getConnection()->executeQuery(self::INSERT_MUNICIPIO,$params);
			self::controlTransaction('commit');
			return true;
		}catch(\Exception $e){
			self::controlTransaction('rollback');
			//throw $e;
		}
	}
	
	private function saveBairro($params){
		self::controlTransaction('begin');
		try{
			$this->entityManager->getConnection()->executeQuery(self::INSERT_BAIRRO,$params);
			self::controlTransaction('commit');
			return true;
		}catch(\Exception $e){
			self::controlTransaction('rollback');
			//throw $e;
		}
	}
    
    private function buscaBairro($params){
    	
    	$params_BAIRRO[':CDPAIS'] = $params[':CDPAIS'];
		$params_BAIRRO[':SGESTADO'] = $params[':SGESTADO'];
		$params_BAIRRO[':CDMUNICIPIO'] = $params[':CDMUNICIPIO'];
		$params_BAIRRO[':NMBAIRRO'] = $this->upperCase($params[':CDBAIRRO']);
		$params_BAIRRO[':NMBAIRRO2'] = $this->upperCase($params[':CDBAIRRO'], true);
		
		$result = $this->entityManager->getConnection()->fetchAll(self::GET_BAIRRO, $params_BAIRRO);
		
		if(!empty($result)){
			$params[':CDBAIRRO'] = $result[0]['CDBAIRRO'];
		}else{
			
			//verifica se ha dados para inserir na table de municipio
			if(!empty($params[':CDPAIS']) && !empty($params[':SGESTADO']) && !empty($params[':CDMUNICIPIO']) && !empty($params_BAIRRO[':NMBAIRRO2']) && !empty($params[':NRORG'])){
				$params_insert_bairro = array();
				$params_insert_bairro[':CDPAIS'] = $params[':CDPAIS'];
				$params_insert_bairro[':SGESTADO'] = $params[':SGESTADO'];
				$params_insert_bairro[':CDMUNICIPIO'] = $params[':CDMUNICIPIO'];
				$params_insert_bairro[':CDBAIRRO'] = $this->getNovoCodigoSeq('BAIRRO'.$params[':CDPAIS'].$params[':SGESTADO'].$params[':CDMUNICIPIO'],$params[':NRORG']);
				$params_insert_bairro[':NMBAIRRO'] = $params_BAIRRO[':NMBAIRRO2'];
				$params_insert_bairro[':NRORG'] = $params[':NRORG'];
				$params_insert_bairro[':DTINCLUSAO'] = date('d/m/Y');
				$params_insert_bairro[':IDATIVO'] = 'S';
				
				if($this->saveBairro($params_insert_bairro)){
					$params[':CDBAIRRO'] = $params_insert_bairro[':CDBAIRRO'];
				}else{
					$params[':CDBAIRRO'] = '';
				}
			}else{
				$params[':CDBAIRRO'] = '';
			}
		}
		
		return $params;
    }
	
	private function lastMunicipio(){
		
		$lastMunicipio = $this->entityManager->getConnection()->fetchAll(self::GET_LAST_MUNICIPIO);
		if(!empty($lastMunicipio)){
			$cdmunicpio = $lastMunicipio[0]['CDMUNICIPIO'] + 1;
		}else{
			$cdmunicpio = '';
		}
		return $cdmunicpio;
	}
	

	private function validateCPF($NRCPFRESPCON) {
		
		if(!empty($NRCPFRESPCON)) {
			$NRCPFRESPCON = str_replace('.', '', $NRCPFRESPCON);
			$NRCPFRESPCON = str_replace('-', '', $NRCPFRESPCON);
	        $invalidos = array(
	            '00000000000',
	            '11111111111',
	            '22222222222',
	            '33333333333',
	            '44444444444',
	            '55555555555',
	            '66666666666',
	            '77777777777',
	            '88888888888',
	            '99999999999');
	        if (in_array($NRCPFRESPCON, $invalidos))
	        	//throw new \Exception("CPF inválido.");
	        	return false;
	        $NRCPFRESPCON = preg_replace('/[^0-9]/', '', (string) $NRCPFRESPCON);
			// Valida tamanho
	        if (strlen($NRCPFRESPCON) != 11)
				//throw new \Exception("CPF inválido.");
				return false;
	        // Calcula e confere primeiro dígito verificador
	        for ($i = 0, $j = 10, $soma = 0; $i < 9; $i++, $j--)
	            $soma += $NRCPFRESPCON[$i] * $j;
	        $resto = $soma % 11;
	        if ($NRCPFRESPCON[9] != ($resto < 2 ? 0 : 11 - $resto))
				//throw new \Exception("CPF inválido.");
				return false;
	        // Calcula e confere segundo dígito verificador
	        for ($i = 0, $j = 11, $soma = 0; $i < 10; $i++, $j--)
	            $soma += $NRCPFRESPCON[$i] * $j;
	        $resto = $soma % 11;
	        if($NRCPFRESPCON[10] != ($resto < 2 ? 0 : 11 - $resto)) {
				//throw new \Exception("CPF inválido.");
				return false;
			};
		
			return true;
		}
		else{
			return true;
			
		}
    }
    
    public function saveConsumidorArqFun($params, $consumidores, &$arrayRetorno){
    	$params = $this->getNovoCodigo($params, ':CDIDCONSUMID');
		$consumidoresAlreadyExists = self::checkConsumidoresAlreadyExists($params, $consumidores);
		$this->controlTransaction('begin');
		try{
			if($consumidoresAlreadyExists == NULL){
				//SAVE
				$this->entityManager->getConnection()->executeQuery(self::INSERT_COMSUMIDORES_ARQFUN, $params);
				$arrayRetorno['log'][]  = 'Consumidor: '.$params[':NMCONSUMIDOR'].' - '.$params[':CDCONSUMIDOR'].' INSERIDO.';
				$arrayRetorno['rowsInsert']++;
			} else {
				//UPDATE
				$this->entityManager->getConnection()->executeQuery(self::UPDATE_COMSUMIDORES_ARQFUN, $params);
				$arrayRetorno['log'][]  = 'Consumidor: '.$params[':NMCONSUMIDOR'].' - '.$params[':CDCONSUMIDOR'].' ATUALIZADO.';
				$arrayRetorno['rowsUpdate']++;
			}
		}catch (\Exception $e) {
			$this->controlTransaction('rollback');
            $arrayRetorno['log'][]  = 'Consumidor: '.$params[':NMCONSUMIDOR'].' - '.$params[':CDCONSUMIDOR'].' Apresentou errou ao salvar informações.';
            $arrayRetorno['rowsError']++;
        } finally {
            $this->controlTransaction('commit');
        }
		return $arrayRetorno;
    }
    
    public function checkConsumidoresAlreadyExists($params, $consumidores){
        return array_filter($consumidores, function($p) use ($params, $consumidores){
                    return $consumidores[$p]['CDCONSUMIDOR'] == $params[':CDCONSUMIDOR'];
            }, ARRAY_FILTER_USE_KEY);
    }
    
    public function getAllConsumidores($rows){
    	$params = array(
    		':CDCLIENTE' => $rows['CDCLIENTE']
    		);
    	return $this->entityManager->getConnection()->fetchAll(self::GET_COMSUMIDORES, $params);
    }
    
    public function setIDSITCONSUMI(){
    	return $this->entityManager->getConnection()->executeQuery(self::SET_IDSITCONSUMI);
    }
    
    
    public function buildReportParams($conditions){
    	
        	if(array_key_exists('CDCLIENTE', $conditions)){
            unset($conditions['CDCLIENTE']);
        	};
        	
            $conditions 	= $this->addParams($conditions,'CDFILIAL');
			$conditions 	= $this->addParams($conditions,'CDCLIENTE');
			$conditions 	= $this->addParams($conditions,'CDTIPOCONS');
			$conditions		= $this->addParams($conditions,'CDCONSUMIDOR');
            $conditions['P_NRORG'] 	= $conditions['NRORG'];
        
        $params = array(
            'ParametersRow' => $conditions,
            'ReportName'    => 'FichaConsumidor'
        );
        
        return $params;
    }
      
        
    
    
    public function addParams($conditions,$param){
        
        if(!array_key_exists($param, $conditions)) {
            $conditions['P_'.$param] = '';
            $conditions['P_'.'T'.$param] = 'T';
        }else{
        	
            $conditions['P_'.$param] = implode('_', $conditions[$param]);
            $conditions['P_'.'T'.$param] = '';
        }
        return $conditions;
    }
	
	const GET_LAST_MUNICIPIO = "SELECT CAST(CDMUNICIPIO AS INTEGER) AS CDMUNICIPIO FROM MUNICIPIO ORDER BY CDMUNICIPIO DESC";
	
	const GET_CAMAPANHA = "SELECT CDCAMPANHA FROM CAMPANHA WHERE ROWNUM = 1";
	
	const GET_CUSTOCLIENTE = "SELECT CDCLIENTE, CDCCUSCLIE, NRORG FROM CCUSCLIE WHERE CDCLIENTE = :CDCLIENTE";
	
	const GET_CUSTOCLIENTE_SELECIONADO = "SELECT CDCLIENTE, CDCCUSCLIE, NRORG FROM CCUSCLIE WHERE CDCLIENTE = :CDCLIENTE AND CDCCUSCLIE =:CDCCUSCLIE";
	
	const GET_TIPOCONSPADRAO = "SELECT CDTIPOCONSFD AS CDTIPOCONS FROM PARAMGERAL";
	
	const GET_TIPOCONSELECIONADO = "SELECT CDTIPOCONS, NMTIPOCONS, IDREGDUPCATR, IDEMISEXTRSIMPL, IDDESABPESQCON, IDSOLSENHCONS, IDPERTRANSALD, IDINACONSIMPARQ, NRORG FROM TIPOCONS where CDTIPOCONS=:CDTIPOCONS ORDER BY CDTIPOCONS";
	
	const GET_TIPOCONSCLIENTE = "SELECT * FROM TIPOCONSCLI WHERE CDCLIENTE = :CDCLIENTE";
	
	const GET_CONSUMIDOR_IMPORTADO = "SELECT COUNT(*) AS TOT FROM CONSUMIDOR WHERE (NRCPFRESPCON = :NRCPFRESPCON) OR (CDCONSUMIDOR = :CDCONSUMIDOR)";
	
	
	const INSERT_CONSUMIDOR_IMPORTADO = "
	INSERT
		INTO CONSUMIDOR
		  (
		    CDCLIENTE,
		    NMCONSUMIDOR,
		    CDCONSUMIDOR,
		    IDSITCONSUMI,
		    CDPAIS,
		    SGESTADO,
		    CDMUNICIPIO,
		    CDCCUSCLIE,
		    CDIDCONSUMID,
		    NRCEPCONS,
		    NRTELECONS,
		    NRCELULARCONS,
		    DSEMAILCONS,
		    CDBAIRRO,
		    NRORG,
		    DTINCLUSAO,
		    DTULTATU,
		    IDATIVO,
		    DTCRIACONS,
		    DSENDECONS,
		    NRCPFRESPCON,
		    DTNASCCONS,
		    CDSENHACONSMD5,
		    CDTIPOCONS,
		    IDSEXOCONS
		    
		  )
		  VALUES
		  (
		    :CDCLIENTE,
		    :NMCONSUMIDOR,
		    :CDCONSUMIDOR,
		    :IDSITCONSUMI,
		    :CDPAIS,
		    :SGESTADO,
		    :CDMUNICIPIO,
		    :CDCCUSCLIE,
		    :CDIDCONSUMID,
		    :NRCEPCONS,
		    :NRTELECONS,
		    :NRCELULARCONS,
		    :DSEMAILCONS,
		    :CDBAIRRO,
		    :NRORG,
		    :DTINCLUSAO,
		    :DTULTATU,
		    :IDATIVO,
		    :DTCRIACONS,
		    :DSENDECONS,
		    :NRCPFRESPCON,
		    :DTNASCCONS,
		    :CDSENHACONSMD5,
		    :CDTIPOCONS,
		    :IDSEXOCONS
		   )";
	
	
	const INSERT_CONSUMIDOR_MOVPONTOCONS = "
	INSERT
		INTO MOVPONTOCONS
		  (
		    CDCAMPANHA,
		    CDCLIENTE,
		    CDCONSUMIDOR,
		    NRSEQMOVCONS,
		    IDTPMOVCONS,
		    VRMOVPONTOCONS,
		    DTMOVPONTOCONS,
		    NRORG,
		    DTINCLUSAO,
		    DTULTATU,
		    DSOBSMOVPTOCONS,
		    VRSALDOCONS,
		    IDATIVO
		  )
		  VALUES
		  (
		    :CDCAMPANHA,
		    :CDCLIENTE,
		    :CDCONSUMIDOR,
		    :NRSEQMOVCONS,
		    :IDTPMOVCONS,
		    :VRMOVPONTOCONS,
		    :DTMOVPONTOCONS,
		    :NRORG,
		    :DTINCLUSAO,
		    :DTULTATU,
		    :DSOBSMOVPTOCONS,
		    :VRSALDOCONS,
		    :IDATIVO
		   )";
    
    const INSERT_MUNICIPIO = "
	INSERT
		INTO MUNICIPIO
		  (
		    CDPAIS,
		    SGESTADO,
		    CDMUNICIPIO,
		    NMMUNICIPIO,
		    IDMUNIUTCONVNFE,
		    NRORG,
		    DTINCLUSAO,
		    IDATIVO
		  )
		  VALUES
		  (
		    :CDPAIS,
		    :SGESTADO,
		    :CDMUNICIPIO,
		    :NMMUNICIPIO,
		    :IDMUNIUTCONVNFE,
		    :NRORG,
		    :DTINCLUSAO,
		    :IDATIVO
		   )";
		   
	const INSERT_BAIRRO = "
	INSERT
		INTO BAIRRO
		  (
		    CDPAIS,
		    SGESTADO,
		    CDMUNICIPIO,
		    CDBAIRRO,
		    NMBAIRRO,
		    NRORG,
		    DTINCLUSAO,
		    IDATIVO
		  )
		  VALUES
		  (
		    :CDPAIS,
		    :SGESTADO,
		    :CDMUNICIPIO,
		    :CDBAIRRO,
		    :NMBAIRRO,
		    :NRORG,
		    :DTINCLUSAO,
		    :IDATIVO
		   )";
	
	const GET_ESTADO = "SELECT SGESTADO, CDPAIS FROM ESTADO WHERE SGESTADO = :SGESTADO OR UPPER(NMESTADO) =:NMESTADO";
	const GET_MUNICIPIO = "SELECT CDMUNICIPIO, NMMUNICIPIO, SGESTADO, CDPAIS  FROM MUNICIPIO WHERE (UPPER(NMMUNICIPIO) = :NMMUNICIPIO OR UPPER(NMMUNICIPIO) = :NMMUNICIPIO2)";
	const GET_BAIRRO = "SELECT CDBAIRRO, NMBAIRRO FROM BAIRRO WHERE CDMUNICIPIO = :CDMUNICIPIO AND SGESTADO = :SGESTADO AND CDPAIS = :CDPAIS AND (UPPER(NMBAIRRO) = :NMBAIRRO OR UPPER(NMBAIRRO) = :NMBAIRRO2)";
	
	const GET_CONSUMIDOR_ALTERACAO_AUTOMATICA = "
	SELECT
		CO.CDCLIENTE||CO.CDCONSUMIDOR AS CDCLIENCONSUMIDOR, CO.CDCONSUMIDOR, CO.NMCONSUMIDOR, CO.CDIDCONSUMID, '' AS IDMARCADO
		FROM
		CONSUMIDOR CO, CLIENTE CL, CLIENFILIAL CF
		WHERE
		(CL.CDCLIENTE = CO.CDCLIENTE) AND
		(CL.CDCLIENTE = CF.CDCLIENTE) AND
		(CL.NRORG = CO.NRORG) AND
		(CL.NRORG = CF.NRORG) AND
		(CF.CDFILIAL = :CDFILIAL ) AND
		(INSTR(:CDCLIENTE , CO.CDCLIENTE ) > 0) AND
		(INSTR(:CDCLIENTECUSCLIE, CO.CDCLIENTE||CO.CDCCUSCLIE) > 0)AND
		(INSTR(:CDTIPOCONSCLIE, CO.CDCLIENTE||CO.CDTIPOCONS) > 0) 
		ORDER BY
		CO.CDCONSUMIDOR
	";
	
		const SAVE_ALTERACAO_AUTOMATICA_SALDO_VND = "
	   UPDATE CONSUMIDOR
		SET VRAVIDEBCONS    = :VRAVIDEBCONS,
		    VRLIMDEBCONS    = :VRLIMDEBCONS,
		    VRMAXDEBCONS    = :VRMAXDEBCONS,
		    VRAVICREDCONS   = :VRAVICREDCONS,
		    VRLIMCREDCONS   = :VRLIMCREDCONS,
		    VRMAXCREDCONS   = :VRMAXCREDCONS
		WHERE
		   (INSTR(:CDCLIENTE, CDCLIENTE) > 0) AND
		   (INSTR(:CDCLIENTECUSCLIE, CDCLIENTE||CDCCUSCLIE) > 0) AND
		   (INSTR(:CDCLIENTIPOCONS, CDCLIENTE||CDTIPOCONS)   > 0) AND
		   (INSTR(:CDCLIENCONSUMIDOR, CDCLIENTE||CDCONSUMIDOR) > 0)
	";
	
	const SAVE_ALTERACAO_AUTOMATICA_SALDO_VND_ID = "
	   UPDATE CONSUMIDOR
		SET IDVERSALDCON	= :IDVERSALDCON
		WHERE
		   (INSTR(:CDCLIENTE, CDCLIENTE) > 0) AND
		   (INSTR(:CDCLIENTECUSCLIE, CDCLIENTE||CDCCUSCLIE) > 0) AND
		   (INSTR(:CDCLIENTIPOCONS, CDCLIENTE||CDTIPOCONS)   > 0) AND
		   (INSTR(:CDCLIENCONSUMIDOR, CDCLIENTE||CDCONSUMIDOR) > 0)
	";
	
	const SAVE_ALTERACAO_AUTOMATICA_CDTIPOCONS = "
	   UPDATE CONSUMIDOR
		SET 
		    CDTIPOCONS      = :P_CDTIPOCONS
		WHERE
		   (INSTR(:CDCLIENTE, CDCLIENTE) > 0) AND
		   (INSTR(:CDCLIENTECUSCLIE, CDCLIENTE||CDCCUSCLIE) > 0) AND
		   (INSTR(:CDCLIENTIPOCONS, CDCLIENTE||CDTIPOCONS)   > 0) AND
		   (INSTR(:CDCLIENCONSUMIDOR, CDCLIENTE||CDCONSUMIDOR) > 0)
	";
	
	const SAVE_ALTERACAO_AUTOMATICA_SALDO = "
	   UPDATE CONSUMIDOR
		SET VRMESUBCONS     = :VRMESUBCONS,
		    VRPESUBCONS     = :VRPESUBCONS
		WHERE
		   (INSTR(:CDCLIENTE, CDCLIENTE) > 0) AND
		   (INSTR(:CDCLIENTECUSCLIE, CDCLIENTE||CDCCUSCLIE) > 0) AND
		   (INSTR(:CDCLIENTIPOCONS, CDCLIENTE||CDTIPOCONS)   > 0) AND
		   (INSTR(:CDCLIENCONSUMIDOR, CDCLIENTE||CDCONSUMIDOR) > 0)
	";
	
	const SAVE_ALTERACAO_AUTOMATICA_CDCCUSCLIE = "
	   UPDATE CONSUMIDOR
		SET CDCCUSCLIE      = :P_CDCCUSCLIE
		WHERE
		   (INSTR(:CDCLIENTE, CDCLIENTE) > 0) AND
		   (INSTR(:CDCLIENTECUSCLIE, CDCLIENTE||CDCCUSCLIE) > 0) AND
		   (INSTR(:CDCLIENTIPOCONS, CDCLIENTE||CDTIPOCONS)   > 0) AND
		   (INSTR(:CDCLIENCONSUMIDOR, CDCLIENTE||CDCONSUMIDOR) > 0)
	";
	
	const SAVE_ALTERACAO_AUTOMATICA_TPVENDA = "
	   UPDATE CONSUMIDOR
		SET IDTPVENDACONS    = :IDTPVENDACONS
		WHERE
		   (INSTR(:CDCLIENTE, CDCLIENTE) > 0) AND
		   (INSTR(:CDCLIENTECUSCLIE, CDCLIENTE||CDCCUSCLIE) > 0) AND
		   (INSTR(:CDCLIENTIPOCONS, CDCLIENTE||CDTIPOCONS)   > 0) AND
		   (INSTR(:CDCLIENCONSUMIDOR, CDCLIENTE||CDCONSUMIDOR) > 0)
	";
	
	/* Queries automáticas para alterar mais de um individuo */
	
	const SAVE_ALTERACAO_AUTOMATICA_SALDO_VND_EVERYONE = "
	   UPDATE CONSUMIDOR
		SET VRAVIDEBCONS    = :VRAVIDEBCONS,
		    VRLIMDEBCONS    = :VRLIMDEBCONS,
		    VRMAXDEBCONS    = :VRMAXDEBCONS,
		    VRAVICREDCONS   = :VRAVICREDCONS,
		    VRLIMCREDCONS   = :VRLIMCREDCONS,
		    VRMAXCREDCONS   = :VRMAXCREDCONS
		WHERE
		   (INSTR(:CDCLIENTE, CDCLIENTE) > 0)
	";
	
	const SAVE_ALTERACAO_AUTOMATICA_TPVENDA_EVERYONE = "
	   UPDATE CONSUMIDOR
		SET IDTPVENDACONS    = :IDTPVENDACONS
		WHERE
		   (INSTR(:CDCLIENTE, CDCLIENTE) > 0)
	";
	
	const SAVE_ALTERACAO_AUTOMATICA_SALDO_VND_ID_EVERYONE = "
	   UPDATE CONSUMIDOR
		SET IDVERSALDCON	= :IDVERSALDCON
		WHERE
		   (INSTR(:CDCLIENTE, CDCLIENTE) > 0)
	";

	const SAVE_ALTERACAO_AUTOMATICA_CDTIPOCONS_EVERYONE = "
	   UPDATE CONSUMIDOR
		SET 
		    CDTIPOCONS      = :P_CDTIPOCONS
		WHERE
		   (INSTR(:CDCLIENTE, CDCLIENTE) > 0)
	";
	
	const SAVE_ALTERACAO_AUTOMATICA_CDCCUSCLIE_EVERYONE = "
	   UPDATE CONSUMIDOR
		SET CDCCUSCLIE      = :P_CDCCUSCLIE
		WHERE
		   (INSTR(:CDCLIENTE, CDCLIENTE) > 0)
	";
	
	const SAVE_ALTERACAO_AUTOMATICA_SALDO_EVERYONE = "
	   UPDATE CONSUMIDOR
		SET VRMESUBCONS     = :VRMESUBCONS,
		    VRPESUBCONS     = :VRPESUBCONS
		WHERE
		   (INSTR(:CDCLIENTE, CDCLIENTE) > 0)
	";
	
	
	const GET_COMSUMIDORES = "
	SELECT * FROM CONSUMIDOR
		WHERE CDCLIENTE = :CDCLIENTE
	";
	
	const SET_IDSITCONSUMI = "
	UPDATE CONSUMIDOR SET IDSITCONSUMI = '2'";
	
	const INSERT_COMSUMIDORES_ARQFUN = "
		INSERT
		INTO CONSUMIDOR
		  (
		    CDCLIENTE,
		    NMCONSUMIDOR,
		    CDCONSUMIDOR,
		    CDTIPOCONS,
		    CDCCUSCLIE,
		    IDSITCONSUMI,
		    CDIDCONSUMID,
		    NRORG,
		    DTINCLUSAO,
		    DTULTATU,
		    CDEXCONSUMID,
		    VRMAXCONSMENSAL,
		    VRMAXDEBCONS,
		    VRLIMDEBCONS,
		    VRAVIDEBCONS,
		    IDVERSALDCON
		  )
		  VALUES
		  (
		    :CDCLIENTE,
		    :NMCONSUMIDOR,
		    :CDCONSUMIDOR,
		    :CDTIPOCONS,
		    :CDCCUSCLIE,
		    '1',
		    :CDIDCONSUMID,
		    :NRORG,
		    SYSDATE,
		    SYSDATE,
		    :CDEXCONSUMID,
		    :VRMAXCONSMENSAL,
		    :VRMAXDEBCONS,
		    :VRLIMDEBCONS,
		    :VRAVIDEBCONS,
		    :IDVERSALDCON
		   )";
		   
	const UPDATE_COMSUMIDORES_ARQFUN = "
		UPDATE
		CONSUMIDOR
			SET
		    NMCONSUMIDOR = :NMCONSUMIDOR,
		    IDSITCONSUMI = '1',
		    CDIDCONSUMID = :CDIDCONSUMID,
		    NRORG		 = :NRORG,
		    DTINCLUSAO	 = SYSDATE,
		    DTULTATU	 = SYSDATE,
		    CDEXCONSUMID = :CDEXCONSUMID,
		    CDTIPOCONS	 = :CDTIPOCONS, 
		    VRMAXCONSMENSAL = :VRMAXCONSMENSAL,
		    VRMAXDEBCONS = :VRMAXDEBCONS,
		    VRLIMDEBCONS = :VRLIMDEBCONS,
		    VRAVIDEBCONS = :VRAVIDEBCONS,
		    IDVERSALDCON = :IDVERSALDCON
		  WHERE 
			CDCONSUMIDOR = :CDCONSUMIDOR AND
			CDCLIENTE = :CDCLIENTE
		  ";
		  
		  
    const BUSCA_VENDAS_CONSUMIDOR = " SELECT *  FROM ( SELECT
	O.CDCLIENTE, C.NMRAZSOCCLIE, C.CDEXCLIENTE, O.CDCONSUMIDOR, O.NMCONSUMIDOR, O.CDIDCONSUMID, O.CDEXCONSUMID,
	(SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) -  NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0))) AS CONSUMO,
    ('01'||TO_CHAR(TO_DATE(:P_DTLANCFIN,'DD/MM/YYYY'),'MM')||TO_CHAR(TO_DATE(:P_DTLANCFIN,'DD/MM/YYYY'),'YYYY')) AS DTNATCORP,
    (TO_CHAR(TO_DATE(:P_DTLANCFIN,'DD/MM/YYYY'),'MM')||TO_CHAR(TO_DATE(:P_DTLANCFIN,'DD/MM/YYYY'),'YYYY')) AS DTPEOPLE
	FROM VENDA V, ITEMVENDA I, PRODUTO P, CLIENTE C, CONSUMIDOR O
	WHERE (V.CDFILIAL = I.CDFILIAL) 
	AND (V.CDCAIXA = I.CDCAIXA) 
	AND (V.NRSEQVENDA = I.NRSEQVENDA) 
	AND (I.CDPRODUTO = P.CDPRODUTO)
	AND (V.CDCLIENTE = C.CDCLIENTE) 
	AND (V.CDCLIENTE = O.CDCLIENTE) 
	AND (V.CDCONSUMIDOR = O.CDCONSUMIDOR) 
	AND (V.CDCONSUMIDOR IS NOT NULL ) 
	AND (V.IDSITUVENDA IN ('O') )
	AND ((INSTR(:P_CDFILIAL, V.CDFILIAL) > 0) OR (:P_TCDFILIAL = 'T'))
	AND (V.DTENTRVENDA BETWEEN :P_DTLANCINI AND :P_DTLANCFIN)     
    AND ((INSTR(:P_CDCONSUMIDOR, V.CDCONSUMIDOR)> 0) OR (:P_TCDCONSUMIDOR = 'T'))
    AND ((INSTR(:P_CDCLIENTE, V.CDCLIENTE)> 0) OR (:P_TCDCLIENTE = 'T'))
    AND ((INSTR(:P_CDTIPOCONS, O.CDTIPOCONS)> 0) OR (:P_TCDTIPOCONS = 'T'))       
    AND ( 
        ((INSTR(:P_CDPRODLIST, P.CDPRODUTO) > 0 )  OR 
         (P.CDARVPROD BETWEEN :P_CDARVPRODI AND :P_CDARVPRODF)) OR 
         (:P_TCDPRODUTO = 'T') 
    )     
	GROUP BY O.CDCLIENTE, C.NMRAZSOCCLIE, C.CDEXCLIENTE, O.CDCONSUMIDOR, O.NMCONSUMIDOR, O.CDIDCONSUMID, O.CDEXCONSUMID
	ORDER BY O.CDCLIENTE, C.NMRAZSOCCLIE, C.CDEXCLIENTE, O.CDCONSUMIDOR, O.NMCONSUMIDOR, O.CDIDCONSUMID, O.CDEXCONSUMID)
    WHERE (UPPER(CDCLIENTE||NMRAZSOCCLIE||CDEXCLIENTE||CDCONSUMIDOR||NMCONSUMIDOR||CDIDCONSUMID||CDEXCONSUMID||CONSUMO||DTNATCORP||DTPEOPLE) like UPPER(:P_ALLFIEDLS)  OR :P_ALLFIEDLS = 'T')";
    
    const GET_CONSUMIDOR_REL = "SELECT
		CO.CDCLIENTE||CO.CDCONSUMIDOR AS CDCLIENCONSUMIDOR, CO.CDCONSUMIDOR, CO.NMCONSUMIDOR, CO.CDIDCONSUMID, '' AS IDMARCADO
		FROM
		CONSUMIDOR CO, CLIENTE CL, CLIENFILIAL CF
		WHERE
		(CL.CDCLIENTE = CO.CDCLIENTE) AND
		(CL.CDCLIENTE = CF.CDCLIENTE) AND
		(CL.NRORG = CO.NRORG) AND
		(CL.NRORG = CF.NRORG) AND
		(CF.CDFILIAL = :CDFILIAL ) AND
		((INSTR(:CDCLIENTE, CO.CDCLIENTE)> 0) OR (:TCDCLIENTE = 'T'))AND
		((INSTR(:CDTIPOCONSCLIE, CO.CDCLIENTE||CO.CDTIPOCONS) > 0) OR (:TCDTIPOCONSCLIE = 'T'))
		ORDER BY
		CO.CDCONSUMIDOR";
	const GET_TIPO_CONSUMIDOR_REL  = "SELECT DISTINCT TCC.CDCLIENTE ||TCC.CDTIPOCONS AS CODIGO,
					                TCC.CDCLIENTE,
					                TCC.CDTIPOCONS,
					                TCC.NMTIPOCONSCLI,
					                TCC.NRORG,
					                T.NMTIPOCONS
					FROM TIPOCONSCLI TCC
					JOIN TIPOCONS T ON TCC.CDTIPOCONS = T.CDTIPOCONS
					WHERE :NRORG = TCC.NRORG
					  AND ((INSTR(:CDCLIENTE, TCC.CDCLIENTE) <> 0) OR (:TCDCLIENTE = 'T'))
					ORDER BY TCC.CDTIPOCONS";
		
	const GET_CONSTOANON = "SELECT NRORG,
										CDCLIENTE,
										CDCONSUMIDOR,
										CDIDCONSUMID,
								        IDSITCONSUMI,
								        NMCONSUMIDOR,
								        NMRESPCONS,
								        NRCPFRESPCON,
								        NRRGCONSUMID,
								        DTNASCCONS,
								        DSEMAILCONS,
								        NRTELECONS,
								        NRTELE2CONS,
								        NRCELULARCONS,
								        DSCOMPLENDECONS,
								        DSREFERENDECONS,
								        DSENDECONS,
								        CDBAIRRO,        
								        NRCEPCONS
								        FROM CONSUMIDOR
								    WHERE  NRORG = :NRORG  
								     AND CDCONSUMIDOR = :CDCONSUMIDOR 
								     AND CDCLIENTE = :CDCLIENTE";
								     
    const GET_ANONIMIZACONS = "SELECT * FROM ANONIMIZACONS WHERE CDCONSUMIDOR = :CDCONSUMIDOR AND CDCLIENTE = :CDCLIENTE";
    
    const INSERT_ANONIMIZACONS = "INSERT INTO ANONIMIZACONS
									   (CDCLIENTE, CDCONSUMIDOR, CDOPERADOR, NMOPERADOR, DTANONIMIZACAO, NMARQANONIMIZA, DSARQANONIMIZA)
									VALUES
									   (:CDCLIENTE, :CDCONSUMIDOR, :CDOPERADOR, :NMOPERADOR, SYSDATE, :NMARQANONIMIZA, :DSARQANONIMIZA)";
    const UPDATE_ANONIMIZACONS = "UPDATE CONSUMIDOR
									   SET NRCPFRESPCON    = :NRCPFRESPCON,
									       NRRGCONSUMID    = :NRRGCONSUMID,
									       NMCONSUMIDOR    = :NMCONSUMIDOR,
									       NMRESPCONS      = :NMRESPCONS,
									       DSEMAILCONS     = :DSEMAILCONS,
									       NRTELECONS      = :NRTELECONS,
									       NRCELULARCONS   = :NRCELULARCONS,
									       NRTELE2CONS     = :NRTELE2CONS,
									       CDIDCONSUMID    = :CDIDCONSUMID,
									       DTNASCCONS      = NULL,
									       DSENDECONS      = NULL,
									       NRENDECONS      = NULL,
									       DSCOMPLENDECONS = NULL,
									       CDBAIRRO        = NULL,
									       NMBAIRCONS      = NULL,
									       NRCEPCONS       = NULL,
									       NMQUADRANTE     = NULL,
									       DSREFERENDECONS = NULL,
									       NRRAMAL1CONS    = NULL,
									       NRRAMAL2CONS    = NULL,
									       NRFAXCONS       = NULL,
									       IDSITCONSUMI    = '2',
									       IDANONIMIZADO   = 'S'
									 WHERE CDCLIENTE    = :CDCLIENTE
									   AND CDCONSUMIDOR = :CDCONSUMIDOR";
   
}