<?php
namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Doctrine\DBAL\Connection;

class EvoluiSaldo {
    /*/
    /* ExtratoCons  /Credito/
    /*/

    protected $connection;
      public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    /*0*/
    public function EvoluiSaldoFunction(&$conditions){
        if(isset( $conditions['CDCLIENTE'])){
            if(isset( $conditions['CDCONSUMIDOR'])){
                if(isset( $conditions['DTMOVEXTCONS'])){
                    if(isset( $conditions['NRORG'])){
                        $allFamilies = $this->getSaldoAllFamilies($conditions);  //adqUltMovExtrato
                        foreach ($allFamilies as &$familie) {
                            $familie['DTMOVEXTCONS'] = $conditions['DTMOVEXTCONS'];
                            $forFamilie = $this->getSaldoForFamilie($familie);   //adqMovExtrato
                            foreach ($forFamilie as $key => &$valuesFamilie) {
                                if($key == 0){
                                    $this->CalculoSaldo($forFamilie[$key], $familie); //adqUltMovExtrato --> VRSALDCONEXT
                                }
                                $this->AtualizaMovimetacaoExtrato($forFamilie[$key]);
                                $SALDOFINAL = $forFamilie[$key]['SALDOFINAL'];
                                if (isset($forFamilie[$key+1])) {
                                    $forFamilie[$key+1]['SALDOFINAL'] = $SALDOFINAL;
                                    $this->CalculoSaldoFinal($forFamilie[$key+1]);
                                }
                                $familie['SALDOFINAL'] = $SALDOFINAL;
                                if (!empty($familie)){
                                    $test = $this->GetVerificaSaldo($familie);
                                    if (empty($test)) {
                                       $this->InsertSaldoCons($familie);
                                    }
                                    else{
                                        $familie['NRORG'] = $conditions['NRORG'];
                                        $this->AtualizaSaldoCons($familie);
                                    }
    				            }     
    				            else{
    					           return $arrayName = array();
    				            }
                            }
    					}
    				}
    			}
    		}
    	}
    }

    /*1*/
    private function getSaldoAllFamilies($conditions){
    	if ($conditions['CDCLIENTE'] == '')
			$conditions['TCDCLIENTE'] = 'T';
		else
			$conditions['TCDCLIENTE'] = ' ';
		if ($conditions['CDCONSUMIDOR'] == '')
			$conditions['TCDCONSUMIDOR'] = 'T';
		else
			$conditions['TCDCONSUMIDOR'] = ' ';
		$params = array(
			':CDCLIENTE'    => $conditions['CDCLIENTE'],
			':TCDCLIENTE'   => $conditions['TCDCLIENTE'],
			':CDCONSUMIDOR' => $conditions['CDCONSUMIDOR'],
			':TCDCONSUMIDOR'=> $conditions['TCDCONSUMIDOR'],
			':DTMOVEXTCONS' => $conditions['DTMOVEXTCONS'],
			':NRORG'        => $conditions['NRORG']
		);
		return $this->connection->fetchAll(self::GET_SALDO_ALL_FAMILIES, $params);
    }

    /*2*/
    private function getSaldoForFamilie($conditions){
		$params = array(
			':CDCLIENTE'    => $conditions['CDCLIENTE'],
			':CDCONSUMIDOR' => $conditions['CDCONSUMIDOR'],
			':CDFAMILISALD' => $conditions['CDFAMILISALD'],
			':DTMOVEXTCONS' => $conditions['DTMOVEXTCONS'],
			':NRORG'        => $conditions['NRORG']
		);
		return $this->connection->fetchAll(self::GET_SALDO_FOR_FAMILIES, $params);
    }

    /*calculo 1 /*3*/
    private function CalculoSaldo(&$conditions, $familie){
		if ($conditions['IDTPMOVEXT'] == 'C'){
        	    $conditions['SALDOFINAL'] = floatval($familie['VRSALDCONEXT']) + floatval($conditions['VRMOVEXTCONS']);
		} else{
      		$conditions['SALDOFINAL'] = floatval($familie['VRSALDCONEXT']) - floatval($conditions['VRMOVEXTCONS']);
		}
      	return $conditions;
    }

    /*4*/
    private function AtualizaMovimetacaoExtrato($conditions){
    	$params = array(
    		':SALDOFINAL'   =>  $conditions['SALDOFINAL'],
    		':CDCLIENTE'    =>  $conditions['CDCLIENTE'],
    		':CDCONSUMIDOR' =>  $conditions['CDCONSUMIDOR'],
    		':CDFAMILISALD' =>  $conditions['CDFAMILISALD'],
    		':DTMOVEXTCONS' =>  $conditions['DTMOVEXTCONS'],
    		':NRSEQMOVEXT'  =>  $conditions['NRSEQMOVEXT'],
    		':NRORG'        =>  $conditions['NRORG']
    	);
    	return $this->connection->executeQuery(self::ATUALIZA_MOVIMENTACAO_EXTRATO, $params);
    }

    /*calculo 2 /*5*/
    private function CalculoSaldoFinal(&$conditions){
		if ($conditions['IDTPMOVEXT'] == 'C'){
        	$conditions['SALDOFINAL'] = floatval($conditions['SALDOFINAL']) + floatval($conditions['VRMOVEXTCONS']);
		} else {
      		$conditions['SALDOFINAL'] = floatval($conditions['SALDOFINAL']) - floatval($conditions['VRMOVEXTCONS']);
		}
      	return $conditions;
    }

    /*6*/
    private function GetVerificaSaldo($conditions) {
    	$params = array(
    		':CDCLIENTE'    => $conditions['CDCLIENTE'],
    		':CDCONSUMIDOR' => $conditions['CDCONSUMIDOR'],
    		':CDFAMILISALD' => $conditions['CDFAMILISALD'],
    		':NRORG'        => $conditions['NRORG']
    	);
    	return $this->connection->fetchAll(self::GET_VERIFICA_SALDO, $params);
    }

    /*7*/
    private function InsertSaldoCons($conditions) {
    	$params = array(
    		':CDCLIENTE'    => $conditions['CDCLIENTE'],
    		':CDCONSUMIDOR' => $conditions['CDCONSUMIDOR'],
    		':CDFAMILISALD' => $conditions['CDFAMILISALD'],
    		':VRSALDCONFAM' => $conditions['SALDOFINAL'],
    		':NRORG'        => $conditions['NRORG']
    	);
    	return $this->connection->executeQuery(self::INSERT_SALDO_CONS, $params);
    }

    /*8*/
    private function AtualizaSaldoCons($conditions) {
    	$params = array(
    		':CDCLIENTE'     => $conditions['CDCLIENTE'],
    		':CDCONSUMIDOR'  => $conditions['CDCONSUMIDOR'],
    		':CDFAMILISALD'  => $conditions['CDFAMILISALD'],
    		':VRSALDCONFAM'  => $conditions['SALDOFINAL'],
    		':NRORG'         => $conditions['NRORG']
    	);
    	return $this->connection->executeQuery(self::ATUALIZA_SALDO_CONS, $params);
    }


    const GET_SALDO_ALL_FAMILIES = "
		    SELECT C.CDCLIENTE, C.NRORG, C.CDCONSUMIDOR,C.CDFAMILISALD,F.DTMOVEXTCONS, NVL(F.VRSALDCONEXT,0) AS VRSALDCONEXT, C.NRORG
          FROM (SELECT C.CDCLIENTE, C.NRORG, C.CDCONSUMIDOR,F.CDFAMILISALD
          		  FROM CONSUMIDOR C, FAMILIASALDO F
          		 WHERE ((CDCLIENTE = :CDCLIENTE) OR (:TCDCLIENTE = 'T' )) 
          		   AND ((CDCONSUMIDOR = :CDCONSUMIDOR) OR (:TCDCONSUMIDOR    = 'T'))
          	   ) C
          LEFT JOIN (SELECT E.CDCLIENTE,E.CDCONSUMIDOR,E.CDFAMILISALD,E.DTMOVEXTCONS, E.VRSALDCONEXT, E.NRORG
          			   FROM EXTRATOCONS E, (SELECT E.CDCLIENTE,E.CDCONSUMIDOR,E.CDFAMILISALD,D.DTMOVEXTCONS, MAX(E.NRSEQMOVEXT) AS NRSEQMOVEXT, E.NRORG
              								  FROM EXTRATOCONS E, (SELECT CDCLIENTE,CDCONSUMIDOR,CDFAMILISALD,MAX(DTMOVEXTCONS) AS DTMOVEXTCONS, NRORG
                  													 FROM EXTRATOCONS
                  													WHERE ((CDCLIENTE = :CDCLIENTE) OR (:TCDCLIENTE = 'T')) 
                  													  AND ((CDCONSUMIDOR = :CDCONSUMIDOR) OR (:TCDCONSUMIDOR = 'T')) 
                  													  AND (DTMOVEXTCONS < :DTMOVEXTCONS)
                  													GROUP BY CDCLIENTE,CDCONSUMIDOR,CDFAMILISALD, NRORG
                 						   						  ) D
						                      WHERE E.CDCLIENTE    = D.CDCLIENTE
						                        AND E.CDCONSUMIDOR = D.CDCONSUMIDOR
						                        AND E.CDFAMILISALD = D.CDFAMILISALD
						                        AND E.DTMOVEXTCONS = D.DTMOVEXTCONS
						                        AND E.NRORG        = D.NRORG
						                      GROUP BY E.CDCLIENTE,E.CDCONSUMIDOR,E.CDFAMILISALD,D.DTMOVEXTCONS, E.NRORG
             							   ) DT
          	 		  WHERE E.CDCLIENTE     = DT.CDCLIENTE
          	 		    AND E.CDCONSUMIDOR  = DT.CDCONSUMIDOR
          	 		    AND E.CDFAMILISALD  = DT.CDFAMILISALD
          	 		    AND E.DTMOVEXTCONS  = DT.DTMOVEXTCONS
          	 		    AND E.NRSEQMOVEXT   = DT.NRSEQMOVEXT
          	 		    AND E.NRORG         = DT.NRORG
         			) F
      		     ON C.CDCLIENTE    = F.CDCLIENTE   
      		    AND C.CDCONSUMIDOR = F.CDCONSUMIDOR
      		    AND C.CDFAMILISALD = F.CDFAMILISALD
      		    AND C.NRORG        = F.NRORG
      		  ORDER BY C.CDCLIENTE,C.CDCONSUMIDOR,C.CDFAMILISALD
    ";

    const GET_SALDO_FOR_FAMILIES = "
		SELECT CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, DTMOVEXTCONS, NRSEQMOVEXT, IDTPMOVEXT, DSOPEEXTCONS, VRMOVEXTCONS, VRSALDCONEXT, 0 AS SALDOFINAL, NRORG
          FROM EXTRATOCONS
      	 WHERE CDCLIENTE     = :CDCLIENTE
		   AND CDCONSUMIDOR  = :CDCONSUMIDOR
		   AND CDFAMILISALD  = :CDFAMILISALD
		   AND DTMOVEXTCONS >= :DTMOVEXTCONS
		   AND NRORG  		 = :NRORG
		 ORDER BY CDFAMILISALD, DTMOVEXTCONS
    ";

    const ATUALIZA_MOVIMENTACAO_EXTRATO="
		UPDATE EXTRATOCONS
      	   SET VRSALDCONEXT = :SALDOFINAL
         WHERE CDCLIENTE    = :CDCLIENTE   
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDFAMILISALD = :CDFAMILISALD
           AND DTMOVEXTCONS = :DTMOVEXTCONS
           AND NRSEQMOVEXT  = :NRSEQMOVEXT 
           AND NRORG        = :NRORG 
    ";

    const GET_VERIFICA_SALDO = "
    	SELECT CDCLIENTE
    	  FROM SALDOCONS
    	 WHERE CDCLIENTE  = :CDCLIENTE
    	   AND CDCONSUMIDOR = :CDCONSUMIDOR
    	   AND CDFAMILISALD = :CDFAMILISALD
    	   AND NRORG = :NRORG
    ";

    const INSERT_SALDO_CONS ="
    	INSERT INTO SALDOCONS (CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, VRSALDCONFAM, NRORG)
    	VALUES (:CDCLIENTE, :CDCONSUMIDOR, :CDFAMILISALD, :VRSALDCONFAM, :NRORG)
    ";

    const ATUALIZA_SALDO_CONS ="
        UPDATE SALDOCONS 
           SET VRSALDCONFAM = :VRSALDCONFAM 
         WHERE CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDFAMILISALD = :CDFAMILISALD
           AND NRORG   = :NRORG
    ";
} 